##// END OF EJS Templates
vidal -
r771:4df6af10b471 Fusion
parent child
Show More
@@ -1,186 +1,189
1 1 #
2 2 # Setup Networking
3 3 #
4 4
5 5 # Load utility functions
6 6 . ./functions.sh
7 7
8 8 # Install and setup hostname
9 9 install_readonly files/network/hostname "${ETC_DIR}/hostname"
10 10 sed -i "s/^RaspberryPI/${HOSTNAME}/" "${ETC_DIR}/hostname"
11 11
12 12 # Install and setup hosts
13 13 install_readonly files/network/hosts "${ETC_DIR}/hosts"
14 14 sed -i "s/RaspberryPI/${HOSTNAME}/" "${ETC_DIR}/hosts"
15 15
16 # Ensure /etc/systemd/network directory is available
17 mkdir -p "${ETC_DIR}/systemd/network"
18
16 19 # Setup hostname entry with static IP
17 20 if [ "$NET_ETH_ADDRESS" != "" ] ; then
18 21 NET_IP=$(echo "${NET_ETH_ADDRESS}" | cut -f 1 -d'/')
19 22 sed -i "s/^127.0.1.1/${NET_IP}/" "${ETC_DIR}/hosts"
20 23 fi
21 24
22 25 # Remove IPv6 hosts
23 26 if [ "$ENABLE_IPV6" = false ] ; then
24 27 sed -i -e "/::[1-9]/d" -e "/^$/d" "${ETC_DIR}/hosts"
25 28 fi
26 29
27 30 # Install hint about network configuration
28 31 install_readonly files/network/interfaces "${ETC_DIR}/network/interfaces"
29 32
30 33 # Install configuration for interface eth0
31 34 install_readonly files/network/eth0.network "${ETC_DIR}/systemd/network/eth0.network"
32 35
33 36 if [ "$RPI_MODEL" = 3P ] ; then
34 37 printf "\n[Link]\nGenericReceiveOffload=off\nTCPSegmentationOffload=off\nGenericSegmentationOffload=off" >> "${ETC_DIR}/systemd/network/eth0.network"
35 38 fi
36 39
37 40 # Install configuration for interface wl*
38 41 install_readonly files/network/wlan0.network "${ETC_DIR}/systemd/network/wlan0.network"
39 42
40 43 #always with dhcp since wpa_supplicant integration is missing
41 44 sed -i -e "s/DHCP=.*/DHCP=yes/" -e "/DHCP/q" "${ETC_DIR}/systemd/network/wlan0.network"
42 45
43 46 if [ "$ENABLE_ETH_DHCP" = true ] ; then
44 47 # Enable DHCP configuration for interface eth0
45 48 sed -i -e "s/DHCP=.*/DHCP=yes/" -e "/DHCP/q" "${ETC_DIR}/systemd/network/eth0.network"
46 49
47 50 # Set DHCP configuration to IPv4 only
48 51 if [ "$ENABLE_IPV6" = false ] ; then
49 52 sed -i "s/DHCP=.*/DHCP=v4/" "${ETC_DIR}/systemd/network/eth0.network"
50 53 sed '/IPv6PrivacyExtensions=true/d' "${ETC_DIR}/systemd/network/eth0.network"
51 54 fi
52 55
53 56 else # ENABLE_ETH_DHCP=false
54 57 # Set static network configuration for interface eth0
55 58 if [ -n NET_ETH_ADDRESS ] && [ -n NET_ETH_GATEWAY ] && [ -n NET_ETH_DNS_1 ] ; then
56 59 sed -i\
57 60 -e "s|DHCP=.*|DHCP=no|"\
58 61 -e "s|Address=\$|Address=${NET_ETH_ADDRESS}|"\
59 62 -e "s|Gateway=\$|Gateway=${NET_ETH_GATEWAY}|"\
60 63 -e "0,/DNS=\$/ s|DNS=\$|DNS=${NET_ETH_DNS_1}|"\
61 64 -e "0,/DNS=\$/ s|DNS=\$|DNS=${NET_ETH_DNS_2}|"\
62 65 -e "s|Domains=\$|Domains=${NET_ETH_DNS_DOMAINS}|"\
63 66 -e "0,/NTP=\$/ s|NTP=\$|NTP=${NET_ETH_NTP_1}|"\
64 67 -e "0,/NTP=\$/ s|NTP=\$|NTP=${NET_ETH_NTP_2}|"\
65 68 "${ETC_DIR}/systemd/network/eth0.network"
66 69 fi
67 70 fi
68 71
69 72
70 73 if [ "$ENABLE_WIRELESS" = true ] ; then
74 mkdir -p "${ETC_DIR}/wpa_supplicant"
71 75 if [ "$ENABLE_WIFI_DHCP" = true ] ; then
72 76 # Enable DHCP configuration for interface eth0
73 77 sed -i -e "s/DHCP=.*/DHCP=yes/" -e "/DHCP/q" "${ETC_DIR}/systemd/network/wlan0.network"
74 78
75 79 # Set DHCP configuration to IPv4 only
76 80 if [ "$ENABLE_IPV6" = false ] ; then
77 81 sed -i "s/DHCP=.*/DHCP=v4/" "${ETC_DIR}/systemd/network/wlan0.network"
78 82 sed '/IPv6PrivacyExtensions=true/d' "${ETC_DIR}/systemd/network/wlan0.network"
79 83 fi
80 84
81 85 else # ENABLE_WIFI_DHCP=false
82 86 # Set static network configuration for interface eth0
83 87 if [ -n NET_WIFI_ADDRESS ] && [ -n NET_WIFI_GATEWAY ] && [ -n NET_WIFI_DNS_1 ] ; then
84 88 sed -i\
85 89 -e "s|DHCP=.*|DHCP=no|"\
86 90 -e "s|Address=\$|Address=${NET_WIFI_ADDRESS}|"\
87 91 -e "s|Gateway=\$|Gateway=${NET_WIFI_GATEWAY}|"\
88 92 -e "0,/DNS=\$/ s|DNS=\$|DNS=${NET_WIFI_DNS_1}|"\
89 93 -e "0,/DNS=\$/ s|DNS=\$|DNS=${NET_WIFI_DNS_2}|"\
90 94 -e "s|Domains=\$|Domains=${NET_WIFI_DNS_DOMAINS}|"\
91 95 -e "0,/NTP=\$/ s|NTP=\$|NTP=${NET_WIFI_NTP_1}|"\
92 96 -e "0,/NTP=\$/ s|NTP=\$|NTP=${NET_WIFI_NTP_2}|"\
93 97 "${ETC_DIR}/systemd/network/wlan0.network"
94 98 fi
95 99 fi
96 100
97 if [ -z "$NET_WIFI_SSID" ] && [ -z "$NET_WIFI_PSK" ] ; then
98 printf "
101 if [ ! -z "$NET_WIFI_SSID" ] && [ ! -z "$NET_WIFI_PSK" ] ; then
102 chroot_exec printf "
99 103 ctrl_interface=/run/wpa_supplicant
100 ctrl_interface_group=wheel
101 104 update_config=1
102 105 eapol_version=1
103 106 ap_scan=1
104 107 fast_reauth=1
105 108
106 " > /etc/wpa_supplicant/wpa_supplicant-wlan0.conf
109 " > "${ETC_DIR}/wpa_supplicant/wpa_supplicant-wlan0.conf"
107 110
108 111 #Configure WPA_supplicant
109 chroot_exec wpa_passphrase "$NET_SSID" "$NET_WPAPSK" >> /etc/wpa_supplicant/wpa_supplicant-wlan0.conf
112 chroot_exec wpa_passphrase "$NET_WIFI_SSID" "$NET_WIFI_PSK" >> "${ETC_DIR}/wpa_supplicant/wpa_supplicant-wlan0.conf"
110 113
111 114 chroot_exec systemctl enable wpa_supplicant.service
112 115 chroot_exec systemctl enable wpa_supplicant@wlan0.service
113 116 fi
114 117 # Remove empty settings from wlan configuration
115 118 sed -i "/.*=\$/d" "${ETC_DIR}/systemd/network/wlan0.network"
116 119 # If WLAN is enabled copy wlan configuration too
117 120 mv -v "${ETC_DIR}/systemd/network/wlan0.network" "${LIB_DIR}/systemd/network/11-wlan0.network"
118 121 fi
119 122
120 123 # Remove empty settings from network configuration
121 124 sed -i "/.*=\$/d" "${ETC_DIR}/systemd/network/eth0.network"
122 125
123 126 # Move systemd network configuration if required by Debian release
124 127 mv -v "${ETC_DIR}/systemd/network/eth0.network" "${LIB_DIR}/systemd/network/10-eth0.network"
125 128
126 129 #Clean up
127 130 rm -fr "${ETC_DIR}/systemd/network"
128 131
129 132 # Enable systemd-networkd service
130 133 chroot_exec systemctl enable systemd-networkd
131 134
132 135 # Install host.conf resolver configuration
133 136 install_readonly files/network/host.conf "${ETC_DIR}/host.conf"
134 137
135 138 # Enable network stack hardening
136 139 if [ "$ENABLE_HARDNET" = true ] ; then
137 140 # Install sysctl.d configuration files
138 141 install_readonly files/sysctl.d/82-rpi-net-hardening.conf "${ETC_DIR}/sysctl.d/82-rpi-net-hardening.conf"
139 142
140 143 # Setup resolver warnings about spoofed addresses
141 144 sed -i "s/^# spoof warn/spoof warn/" "${ETC_DIR}/host.conf"
142 145 fi
143 146
144 147 # Enable time sync
145 148 if [ "$NET_NTP_1" != "" ] ; then
146 149 chroot_exec systemctl enable systemd-timesyncd.service
147 150 fi
148 151
149 152 # Download the firmware binary blob required to use the RPi3 wireless interface
150 153 if [ "$ENABLE_WIRELESS" = true ] ; then
151 154 if [ ! -d "${WLAN_FIRMWARE_DIR}" ] ; then
152 155 mkdir -p "${WLAN_FIRMWARE_DIR}"
153 156 fi
154 157
155 158 # Create temporary directory for firmware binary blob
156 159 temp_dir=$(as_nobody mktemp -d)
157 160
158 161 # Fetch firmware binary blob for RPI3B+
159 162 if [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
160 163 # Fetch firmware binary blob for RPi3P
161 164 as_nobody wget -q -O "${temp_dir}/brcmfmac43455-sdio.bin" "${WLAN_FIRMWARE_URL}/brcmfmac43455-sdio.bin"
162 165 as_nobody wget -q -O "${temp_dir}/brcmfmac43455-sdio.txt" "${WLAN_FIRMWARE_URL}/brcmfmac43455-sdio.txt"
163 166 as_nobody wget -q -O "${temp_dir}/brcmfmac43455-sdio.clm_blob" "${WLAN_FIRMWARE_URL}/brcmfmac43455-sdio.clm_blob"
164 167
165 168 # Move downloaded firmware binary blob
166 169 mv "${temp_dir}/brcmfmac43455-sdio."* "${WLAN_FIRMWARE_DIR}/"
167 170
168 171 # Set permissions of the firmware binary blob
169 172 chown root:root "${WLAN_FIRMWARE_DIR}/brcmfmac43455-sdio."*
170 173 chmod 600 "${WLAN_FIRMWARE_DIR}/brcmfmac43455-sdio."*
171 174 elif [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 0 ] ; then
172 175 # Fetch firmware binary blob for RPi3
173 176 as_nobody wget -q -O "${temp_dir}/brcmfmac43430-sdio.bin" "${WLAN_FIRMWARE_URL}/brcmfmac43430-sdio.bin"
174 177 as_nobody wget -q -O "${temp_dir}/brcmfmac43430-sdio.txt" "${WLAN_FIRMWARE_URL}/brcmfmac43430-sdio.txt"
175 178
176 179 # Move downloaded firmware binary blob
177 180 mv "${temp_dir}/brcmfmac43430-sdio."* "${WLAN_FIRMWARE_DIR}/"
178 181
179 182 # Set permissions of the firmware binary blob
180 183 chown root:root "${WLAN_FIRMWARE_DIR}/brcmfmac43430-sdio."*
181 184 chmod 600 "${WLAN_FIRMWARE_DIR}/brcmfmac43430-sdio."*
182 185 fi
183 186
184 187 # Remove temporary directory for firmware binary blob
185 188 rm -fr "${temp_dir}"
186 189 fi
@@ -1,98 +1,105
1 1 #
2 2 # Reduce system disk usage
3 3 #
4 4
5 5 # Load utility functions
6 6 . ./functions.sh
7 7
8 8 if [ "$ENABLE_IPV6" = false ] ; then
9 9 "$LIB_DIR"/xtables/libip6t_ah.so
10 10 "$LIB_DIR"/xtables/libip6t_dst.so
11 11 "$LIB_DIR"/xtables/libip6t_eui64.so
12 12 "$LIB_DIR"/xtables/libip6t_frag.so
13 13 "$LIB_DIR"/xtables/libip6t_hbh.so
14 14 "$LIB_DIR"/xtables/libip6t_hl.so
15 15 "$LIB_DIR"/xtables/libip6t_HL.so
16 16 "$LIB_DIR"/xtables/libip6t_icmp6.so
17 17 "$LIB_DIR"/xtables/libip6t_ipv6header.so
18 18 "$LIB_DIR"/xtables/libip6t_LOG.so
19 19 "$LIB_DIR"/xtables/libip6t_mh.so
20 20 "$LIB_DIR"/xtables/libip6t_REJECT.so
21 21 "$LIB_DIR"/xtables/libip6t_rt.so
22 22 "$LIB_DIR"/xtables/libip6t_DNAT.so
23 23 "$LIB_DIR"/xtables/libip6t_DNPT.so
24 24 "$LIB_DIR"/xtables/libip6t_MASQUERADE.so
25 25 "$LIB_DIR"/xtables/libip6t_NETMAP.so
26 26 "$LIB_DIR"/xtables/libip6t_REDIRECT.so
27 27 "$LIB_DIR"/xtables/libip6t_SNAT.so
28 28 "$LIB_DIR"/xtables/libip6t_SNPT.so
29 29 fi
30 30 # Reduce the image size by various operations
31 31 if [ "$ENABLE_REDUCE" = true ] ; then
32 32 if [ "$REDUCE_APT" = true ] ; then
33 33 # Install dpkg configuration file
34 34 if [ "$REDUCE_DOC" = true ] || [ "$REDUCE_MAN" = true ] ; then
35 35 install_readonly files/dpkg/01nodoc "${ETC_DIR}/dpkg/dpkg.cfg.d/01nodoc"
36 36 fi
37 37
38 38 # Install APT configuration files
39 39 install_readonly files/apt/02nocache "${ETC_DIR}/apt/apt.conf.d/02nocache"
40 40 install_readonly files/apt/03compress "${ETC_DIR}/apt/apt.conf.d/03compress"
41 41 install_readonly files/apt/04norecommends "${ETC_DIR}/apt/apt.conf.d/04norecommends"
42 42
43 43 # Remove APT cache files
44 44 rm -fr "${R}/var/cache/apt/pkgcache.bin"
45 45 rm -fr "${R}/var/cache/apt/srcpkgcache.bin"
46 46 fi
47 47
48 48 # Remove all doc files
49 49 if [ "$REDUCE_DOC" = true ] ; then
50 50 find "${R}/usr/share/doc" -depth -type f ! -name copyright -print0 | xargs -0 rm || true
51 51 find "${R}/usr/share/doc" -empty -print0 | xargs -0 rmdir || true
52 52 fi
53 53
54 54 # Remove all man pages and info files
55 55 if [ "$REDUCE_MAN" = true ] ; then
56 56 rm -rf "${R}/usr/share/man" "${R}/usr/share/groff" "${R}/usr/share/info" "${R}/usr/share/lintian" "${R}/usr/share/linda" "${R}/var/cache/man"
57 57 fi
58 58
59 59 # Remove all locale translation files
60 60 if [ "$REDUCE_LOCALE" = true ] ; then
61 61 find "${R}/usr/share/locale" -mindepth 1 -maxdepth 1 ! -name 'en' -print0 | xargs -0 rm -r
62 62 fi
63 63
64 64 # Remove hwdb PCI device classes (experimental)
65 65 if [ "$REDUCE_HWDB" = true ] ; then
66 66 rm -fr "/lib/udev/hwdb.d/20-pci-*"
67 67 fi
68 68
69 69 # Replace bash shell by dash shell (experimental)
70 70 if [ "$REDUCE_BASH" = true ] ; then
71 71 # Purge bash and update alternatives
72 72 echo "Yes, do as I say!" | chroot_exec apt-get purge -qq -y --allow-remove-essential bash
73 73 chroot_exec update-alternatives --install /bin/bash bash /bin/dash 100
74 74 fi
75 75
76 76 # Remove sound utils and libraries
77 77 if [ "$ENABLE_SOUND" = false ] ; then
78 chroot_exec apt-get -qq -y purge alsa-utils libsamplerate0 libasound2 libasound2-data
78 if [ "$ENABLE_BLUETOOTH" = false ] ; then
79 chroot_exec apt-get -qq -y purge alsa-utils libsamplerate0 libasound2 libasound2-data
80 else
81 chroot_exec apt-get -qq -y purge alsa-utils libsamplerate0
82 fi
79 83 fi
80 84
81 85 # Remove GPU kernels
82 86 if [ "$ENABLE_MINGPU" = true ] ; then
83 87 rm -f "${BOOT_DIR}/start.elf"
84 88 rm -f "${BOOT_DIR}/fixup.dat"
85 89 rm -f "${BOOT_DIR}/start_x.elf"
86 90 rm -f "${BOOT_DIR}/fixup_x.dat"
87 91 fi
88 92
89 93 # Remove kernel and initrd from /boot (already in /boot/firmware)
90 94 if [ "$BUILD_KERNEL" = false ] ; then
91 95 rm -f "${R}/boot/vmlinuz-*"
92 96 rm -f "${R}/boot/initrd.img-*"
93 97 fi
98
99 #Reduce BOOT
100 #Only necessary files for my gen pi
94 101
95 102 # Clean APT list of repositories
96 103 rm -fr "${R}/var/lib/apt/lists/*"
97 104 chroot_exec apt-get -qq -y update
98 105 fi
@@ -1,924 +1,924
1 #!/bin/sh
1 #!/bin/bash
2 2 ########################################################################
3 3 # rpi23-gen-image.sh 2015-2017
4 4 #
5 5 # Advanced Debian "stretch" and "buster" bootstrap script for Raspberry Pi
6 6 #
7 7 # This program is free software; you can redistribute it and/or
8 8 # modify it under the terms of the GNU General Public License
9 9 # as published by the Free Software Foundation; either version 2
10 10 # of the License, or (at your option) any later version.
11 11 #
12 12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
13 13 #
14 14 # Big thanks for patches and enhancements by 20+ github contributors!
15 15 ########################################################################
16 16
17 17 # Are we running as root?
18 18 if [ "$(id -u)" -ne "0" ] ; then
19 19 echo "error: this script must be executed with root privileges!"
20 20 exit 1
21 21 fi
22 22
23 23 # Check if ./functions.sh script exists
24 24 if [ ! -r "./functions.sh" ] ; then
25 25 echo "error: './functions.sh' required script not found!"
26 26 exit 1
27 27 fi
28 28
29 29 # Load utility functions
30 30 . ./functions.sh
31 31
32 32 # Load parameters from configuration template file
33 33 if [ -n "$CONFIG_TEMPLATE" ] ; then
34 34 use_template
35 35 fi
36 36
37 37 # Introduce settings
38 38 set -e
39 39 echo -n -e "\n#\n# RPi 0/1/2/3/4 Bootstrap Settings\n#\n"
40 40 set -x
41 41
42 42 # Raspberry Pi model configuration
43 43 RPI_MODEL=${RPI_MODEL:=3P}
44 44
45 45 # Debian release
46 46 RELEASE=${RELEASE:=buster}
47 47 if [ $RELEASE = "bullseye" ] ; then
48 48 RELEASE=testing
49 49 fi
50 50
51 51 # Kernel Branch
52 52 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
53 53
54 54 # URLs
55 55 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
56 56 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
57 57 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
58 58 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
59 59 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
60 60 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
61 61 BLUETOOTH_URL=${BLUETOOTH_URL:=https://github.com/RPi-Distro/pi-bluetooth.git}
62 62 NEXMON_URL=${NEXMON_URL:=https://github.com/seemoo-lab/nexmon.git}
63 63 SYSTEMDSWAP_URL=${SYSTEMDSWAP_URL:=https://github.com/Nefelim4ag/systemd-swap.git}
64 64
65 65 # Kernel deb packages for 32bit kernel
66 66 RPI_32_KERNEL_URL=${RPI_32_KERNEL_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel_20180422-141901_armhf.deb}
67 67 RPI_32_KERNELHEADER_URL=${RPI_32_KERNELHEADER_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel-headers_20180422-141901_armhf.deb}
68 68 # Kernel has KVM and zswap enabled - use if KERNEL_* parameters and precompiled kernel are used
69 69 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.19.102.20200211/bcmrpi3-kernel-bis-4.19.102.20200211.tar.xz}
70 70 # Default precompiled 64bit kernel
71 71 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.19.102.20200211/bcmrpi3-kernel-4.19.102.20200211.tar.xz}
72 72 # Sakaki BIS Kernel RPI4 - https://github.com/sakaki-/bcm2711-kernel-bis
73 73 RPI4_64_BIS_KERNEL_URL=${RPI4_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcm2711-kernel-bis/releases/download/4.19.102.20200211/bcm2711-kernel-bis-4.19.102.20200211.tar.xz}
74 74 # Default precompiled 64bit kernel - https://github.com/sakaki-/bcm2711-kernel
75 75 RPI4_64_DEF_KERNEL_URL=${RPI4_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcm2711-kernel-bis/releases/download/4.19.102.20200211/bcm2711-kernel-bis-4.19.102.20200211.tar.xz}
76 76 # Generic
77 77 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_DEF_KERNEL_URL}
78 78 RPI4_64_KERNEL_URL=${RPI4_64_KERNEL_URL:=$RPI4_64_DEF_KERNEL_URL}
79 79 # Kali kernel src - used if ENABLE_NEXMON=true (they patch the wlan kernel modul)
80 80 KALI_KERNEL_URL=${KALI_KERNEL_URL:=https://github.com/Re4son/re4son-raspberrypi-linux.git}
81 81
82 82 # Build directories
83 83 WORKDIR=$(pwd)
84 84 BASEDIR=${BASEDIR:=${WORKDIR}/images/${RELEASE}}
85 85 BUILDDIR="${BASEDIR}/build"
86 86
87 87 # Chroot directories
88 88 R="${BUILDDIR}/chroot"
89 89 ETC_DIR="${R}/etc"
90 90 LIB_DIR="${R}/lib"
91 91 BOOT_DIR="${R}/boot/firmware"
92 92 KERNEL_DIR="${R}/usr/src/linux"
93 93 WLAN_FIRMWARE_DIR="${LIB_DIR}/firmware/brcm"
94 94 BLUETOOTH_FIRMWARE_DIR="${ETC_DIR}/firmware/bt"
95 95
96 96 # APT settings
97 97 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
98 98 APT_PROXY=${APT_PROXY:=""}
99 99 KEEP_APT_PROXY=${KEEP_APT_PROXY:=false}
100 100 # Packages required in the chroot build environment
101 101 APT_INCLUDES=${APT_INCLUDES:=""}
102 102 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup,libnss-systemd"
103 103 # Packages to exclude from chroot build environment
104 104 APT_EXCLUDES=${APT_EXCLUDES:=""}
105 105
106 106 # General settings
107 107 SET_ARCH=${SET_ARCH:=32}
108 108 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
109 109 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
110 110 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
111 111 EXPANDROOT=${EXPANDROOT:=true}
112 112
113 113 ENABLE_ROOT=${ENABLE_ROOT:=false}
114 114 ROOT_PASSWORD=${ROOT_PASSWORD:=raspberry}
115 115 ENABLE_USER=${ENABLE_USER:=true}
116 116 USER_NAME=${USER_NAME:="pi"}
117 117 USER_PASSWORD=${USER_PASSWORD:=raspberry}
118 118
119 119 # Keyboard settings
120 120 XKB_MODEL=${XKB_MODEL:=""}
121 121 XKB_LAYOUT=${XKB_LAYOUT:=""}
122 122 XKB_VARIANT=${XKB_VARIANT:=""}
123 123 XKB_OPTIONS=${XKB_OPTIONS:=""}
124 124
125 125 # Networking settings:
126 126 ENABLE_IPV6=${ENABLE_IPV6:=true}
127 127 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
128 128 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
129 129 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
130 130 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
131 131
132 132 # Network settings (DHCP)
133 133 ENABLE_ETH_DHCP=${ENABLE_ETH_DHCP:=true}
134 134 ENABLE_WIFI_DHCP=${ENABLE_ETH_DHCP:=true}
135 135
136 136 # Network settings (static)
137 137 NET_ETH_ADDRESS=${NET_ETH_ADDRESS:=""}
138 138 NET_ETH_GATEWAY=${NET_ETH_GATEWAY:=""}
139 139 NET_ETH_DNS_1=${NET_ETH_DNS_1:=""}
140 140 NET_ETH_DNS_2=${NET_ETH_DNS_2:=""}
141 141 NET_ETH_DNS_DOMAINS=${NET_ETH_DNS_DOMAINS:=""}
142 142 NET_ETH_NTP_1=${NET_ETH_NTP_1:=""}
143 143 NET_ETH_NTP_2=${NET_ETH_NTP_2:=""}
144 144
145 145 # Networking settings (WIFI):
146 146 NET_WIFI_SSID=${NET_WIFI_SSID:=""}
147 147 NET_WIFI_PSK=${NET_WIFI_PSK:=""}
148 148
149 149 # Network settings (static)
150 150 NET_WIFI_ADDRESS=${NET_WIFI_ADDRESS:=""}
151 151 NET_WIFI_GATEWAY=${NET_WIFI_GATEWAY:=""}
152 152 NET_WIFI_DNS_1=${NET_WIFI_DNS_1:=""}
153 153 NET_WIFI_DNS_2=${NET_WIFI_DNS_2:=""}
154 154 NET_WIFI_DNS_DOMAINS=${NET_WIFI_DNS_DOMAINS:=""}
155 155 NET_WIFI_NTP_1=${NET_WIFI_NTP_1:=""}
156 156 NET_WIFI_NTP_2=${NET_WIFI_NTP_2:=""}
157 157
158 158 # Feature settings
159 159 ENABLE_CONSOLE=${ENABLE_CONSOLE:=false}
160 160 ENABLE_PRINTK=${ENABLE_PRINTK:=false}
161 161 ENABLE_BLUETOOTH=${ENABLE_BLUETOOTH:=false}
162 162 ENABLE_MINIUART_OVERLAY=${ENABLE_MINIUART_OVERLAY:=false}
163 163 ENABLE_TURBO=${ENABLE_TURBO:=false}
164 164 ENABLE_I2C=${ENABLE_I2C:=false}
165 165 ENABLE_SPI=${ENABLE_SPI:=false}
166 166
167 167 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
168 168 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
169 169 ENABLE_SOUND=${ENABLE_SOUND:=false}
170 170 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
171 171 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
172 172 ENABLE_XORG=${ENABLE_XORG:=false}
173 173 ENABLE_WM=${ENABLE_WM:=""}
174 174 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
175 175 ENABLE_SPLASH=${ENABLE_SPLASH:=true}
176 176 ENABLE_LOGO=${ENABLE_LOGO:=true}
177 177 ENABLE_SILENT_BOOT=${ENABLE_SILENT_BOOT=false}
178 178 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
179 179
180 180 # Advanced settings
181 181 ENABLE_DPHYSSWAP=${ENABLE_DPHYSSWAP:=true}
182 182 ENABLE_SYSTEMDSWAP=${ENABLE_SYSTEMDSWAP:=false}
183 183 ENABLE_QEMU=${ENABLE_QEMU:=false}
184 184 ENABLE_KEYGEN=${ENABLE_KEYGEN:=false}
185 185 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
186 186 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
187 187 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
188 188 ENABLE_DBUS=${ENABLE_DBUS:=true}
189 189 ENABLE_USBBOOT=${ENABLE_USBBOOT=false}
190 190 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
191 191 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
192 192 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
193 193 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
194 194 ENABLE_GR_ACCEL=${ENABLE_GR_ACCEL:=true}
195 195 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
196 196 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=false}
197 197 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
198 198 ENABLE_NEXMON=${ENABLE_NEXMON:=false}
199 199 NEXMONSRC_DIR=${NEXMONSRC_DIR:=""}
200 200
201 201 # SSH settings
202 202 SSH_ENABLE=${SSH_ENABLE:=true}
203 203 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
204 204 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
205 205 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
206 206 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
207 207 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
208 208
209 209 # Kernel compilation settings
210 210 BUILD_KERNEL=${BUILD_KERNEL:=true}
211 211 KERNEL_THREADS=${KERNEL_THREADS:=1}
212 212 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
213 213 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
214 214 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
215 215 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
216 216 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
217 217 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
218 218 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
219 219 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
220 220 KERNELSRC_USRCONFIG=${KERNELSRC_USRCONFIG:=""}
221 221 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
222 222 # Firmware directory: Blank if download from github
223 223 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
224 224 KERNEL_DEFAULT_GOV=${KERNEL_DEFAULT_GOV:=ondemand}
225 225 KERNEL_NF=${KERNEL_NF:=false}
226 226 KERNEL_VIRT=${KERNEL_VIRT:=false}
227 227 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
228 228 KERNEL_BPF=${KERNEL_BPF:=false}
229 229 KERNEL_SECURITY=${KERNEL_SECURITY:=false}
230 230 KERNEL_BTRFS=${KERNEL_BTRFS:=false}
231 231 KERNEL_POEHAT=${KERNEL_POEHAT:=false}
232 232 KERNEL_NSPAN=${KERNEL_NSPAN:=false}
233 233 KERNEL_DHKEY=${KERNEL_DHKEY:=true}
234 234
235 235 # Reduce disk usage settings
236 236 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
237 237 REDUCE_APT=${REDUCE_APT:=true}
238 238 REDUCE_DOC=${REDUCE_DOC:=false}
239 239 REDUCE_MAN=${REDUCE_MAN:=false}
240 240 REDUCE_VIM=${REDUCE_VIM:=false}
241 241 REDUCE_BASH=${REDUCE_BASH:=false}
242 242 REDUCE_HWDB=${REDUCE_HWDB:=false}
243 243 REDUCE_SSHD=${REDUCE_SSHD:=false}
244 244 REDUCE_LOCALE=${REDUCE_LOCALE:=false}
245 245 REDUCE_KERNEL=${REDUCE_KERNEL:=false}
246 246
247 247 # Encrypted filesystem settings
248 248 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
249 249 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
250 250 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
251 251 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64"}
252 252 CRYPTFS_HASH=${CRYPTFS_HASH:="sha256"}
253 253 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=256}
254 254 #Dropbear-initramfs supports unlocking encrypted filesystem via SSH on bootup
255 255 CRYPTFS_DROPBEAR=${CRYPTFS_DROPBEAR:=false}
256 256 #Provide your own Dropbear Public RSA-OpenSSH Key otherwise it will be generated
257 257 CRYPTFS_DROPBEAR_PUBKEY=${CRYPTFS_DROPBEAR_PUBKEY:=""}
258 258
259 259 # Packages required for bootstrapping
260 260 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus bison flex libssl-dev sudo"
261 261 MISSING_PACKAGES=""
262 262
263 263 # Packages installed for c/c++ build environment in chroot (keep empty)
264 264 COMPILER_PACKAGES=""
265 265
266 266 # Check if apt-cacher-ng has port 3142 open and set APT_PROXY
267 267 APT_CACHER_RUNNING=$(lsof -i :3142 | cut -d ' ' -f3 | uniq | sed '/^\s*$/d')
268 268 if [ "${APT_CACHER_RUNNING}" = "apt-cacher-ng" ] ; then
269 269 APT_PROXY=http://127.0.0.1:3142/
270 270 fi
271 271
272 272 # Setup architecture specific settings
273 273 if [ -n "$SET_ARCH" ] ; then
274 274 ## 64-bit configuration
275 275 if [ "$SET_ARCH" = 64 ] ; then
276 276 ### General 64-bit depended settings
277 277 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
278 278 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
279 279 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
280 280
281 281 ### Raspberry Pi model specific settings
282 282 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
283 283 if [ "$RPI_MODEL" != 4 ] ; then
284 284 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
285 285 else
286 286 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2711_defconfig}
287 287 fi
288 288
289 289 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
290 290 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
291 291 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
292 292 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
293 293
294 294 else
295 295 echo "error: Only Raspberry PI 3, 3B+ and 4 support 64-bit"
296 296 exit 1
297 297 fi
298 298 fi
299 299
300 300 ## 32-bit configuration
301 301 if [ "$SET_ARCH" = 32 ] ; then
302 302 ### General 32-bit dependend settings
303 303 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
304 304 KERNEL_ARCH=${KERNEL_ARCH:=arm}
305 305 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
306 306
307 307 ### Raspberry Pi (0-1P) model specific settings
308 308 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
309 309 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
310 310 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
311 311 RELEASE_ARCH=${RELEASE_ARCH:=armel}
312 312 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
313 313 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
314 314
315 315 if [ $ENABLE_XORG = true ] ; then
316 316 if [$RELEASE = "stretch" ] || [$RELEASE = "oldstable" ] ; then
317 317 printf "\nBest support for armel architecture is provided under Debian stretch/oldstable. Choose yes to change release to Debian stretch[y/n] "
318 318 read -r confirm
319 319 if [ "$confirm" = "y" ] ; then
320 320 $RELEASE = "stretch"
321 321 fi
322 322 fi
323 323 fi
324 324 fi
325 325 ### Raspberry Pi (2-4) model specific settings
326 326 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
327 327 if [ "$RPI_MODEL" != 4 ] ; then
328 328 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
329 329 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
330 330 else
331 331 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2711_defconfig}
332 332 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7l.img}
333 333 fi
334 334
335 335 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
336 336 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
337 337
338 338 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
339 339 fi
340 340 fi
341 341 # SET_ARCH not set
342 342 else
343 343 echo "error: Please set '32' or '64' as value for SET_ARCH"
344 344 exit 1
345 345 fi
346 346 # Device specific configuration and U-Boot configuration
347 347 case "$RPI_MODEL" in
348 348 0)
349 349 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
350 350 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
351 351 ;;
352 352 1)
353 353 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
354 354 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
355 355 ;;
356 356 1P)
357 357 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
358 358 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
359 359 ;;
360 360 2)
361 361 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
362 362 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
363 363 ;;
364 364 3)
365 365 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
366 366 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
367 367 ;;
368 368 3P)
369 369 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
370 370 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
371 371 ;;
372 372 4)
373 373 DTB_FILE=${DTB_FILE:=bcm2711-rpi-4-b.dtb}
374 374 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_4_defconfig}
375 375 ;;
376 376 *)
377 377 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
378 378 exit 1
379 379 ;;
380 380 esac
381 381
382 382 # Raspberry PI 0,3,3P,4 with Bluetooth and Wifi onboard
383 383 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
384 384 ## Include bluetooth packages on supported boards
385 385 if [ "$ENABLE_BLUETOOTH" = true ] ; then
386 386 APT_INCLUDES="${APT_INCLUDES},bluetooth,bluez"
387 387 fi
388 388 if [ "$ENABLE_WIRELESS" = true ] ; then
389 389 APT_INCLUDES="${APT_INCLUDES},wireless-tools,crda,wireless-regdb,wpasupplicant"
390 390 fi
391 391 # Raspberry PI 1,1P,2 without Wifi and bluetooth onboard
392 392 else
393 393 ## Check if the internal wireless interface is not supported by the RPi model
394 394 if [ "$ENABLE_WIRELESS" = true ] || [ "$ENABLE_BLUETOOTH" = true ]; then
395 395 echo "error: The selected Raspberry Pi model has no integrated interface for wireless or bluetooth"
396 396 exit 1
397 397 fi
398 398 fi
399 399
400 400 if [ "$BUILD_KERNEL" = false ] && [ "$ENABLE_NEXMON" = true ]; then
401 401 echo "error: You have to compile kernel sources, if you want to enable nexmon"
402 402 exit 1
403 403 fi
404 404
405 405 # Prepare date string for default image file name
406 406 DATE="$(date +%Y-%m-%d)"
407 407 if [ -z "$KERNEL_BRANCH" ] ; then
408 408 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
409 409 else
410 410 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
411 411 fi
412 412
413 413 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
414 414 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
415 415 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
416 416 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
417 417 exit 1
418 418 fi
419 419 fi
420 420
421 421 # Add cmake to compile videocore sources
422 422 if [ "$ENABLE_VIDEOCORE" = true ] ; then
423 423 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
424 424 fi
425 425
426 426 # Add deps for nexmon
427 427 if [ "$ENABLE_NEXMON" = true ] ; then
428 428 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libgmp3-dev gawk qpdf make autoconf automake build-essential libtool"
429 429 fi
430 430
431 431 # Add libncurses5 to enable kernel menuconfig
432 432 if [ "$KERNEL_MENUCONFIG" = true ] ; then
433 433 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
434 434 fi
435 435
436 436 # Add ccache compiler cache for (faster) kernel cross (re)compilation
437 437 if [ "$KERNEL_CCACHE" = true ] ; then
438 438 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
439 439 fi
440 440
441 441 # Add cryptsetup package to enable filesystem encryption
442 442 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
443 443 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
444 444 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup,cryptsetup-initramfs"
445 445
446 446 # If cryptfs,dropbear and initramfs are enabled include dropbear-initramfs package
447 447 if [ "$CRYPTFS_DROPBEAR" = true ] && [ "$ENABLE_INITRAMFS" = true ]; then
448 448 APT_INCLUDES="${APT_INCLUDES},dropbear-initramfs"
449 449 fi
450 450
451 451 if [ -z "$CRYPTFS_PASSWORD" ] ; then
452 452 echo "error: no password defined (CRYPTFS_PASSWORD)!"
453 453 exit 1
454 454 fi
455 455 ENABLE_INITRAMFS=true
456 456 fi
457 457
458 458 # Add initramfs generation tools
459 459 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
460 460 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
461 461 fi
462 462
463 463 # Add device-tree-compiler required for building the U-Boot bootloader
464 464 if [ "$ENABLE_UBOOT" = true ] ; then
465 465 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bc"
466 466 fi
467 467
468 468 if [ "$ENABLE_USBBOOT" = true ] ; then
469 469 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 2 ]; then
470 470 echo "error: Booting from USB alone is only supported by Raspberry Pi 3 and 3P"
471 471 exit 1
472 472 fi
473 473 fi
474 474
475 475 # Check if root SSH (v2) public key file exists
476 476 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
477 477 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
478 478 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
479 479 exit 1
480 480 fi
481 481 fi
482 482
483 483 # Check if $USER_NAME SSH (v2) public key file exists
484 484 if [ -n "$SSH_USER_PUB_KEY" ] ; then
485 485 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
486 486 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
487 487 exit 1
488 488 fi
489 489 fi
490 490
491 491 if [ "$ENABLE_NEXMON" = true ] && [ -n "$KERNEL_BRANCH" ] ; then
492 492 echo "error: Please unset KERNEL_BRANCH if using ENABLE_NEXMON"
493 493 exit 1
494 494 fi
495 495
496 496 # Check if all required packages are installed on the build system
497 497 for package in $REQUIRED_PACKAGES ; do
498 498 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
499 499 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
500 500 fi
501 501 done
502 502
503 503 # If there are missing packages ask confirmation for install, or exit
504 504 if [ -n "$MISSING_PACKAGES" ] ; then
505 505 echo "the following packages needed by this script are not installed:"
506 506 echo "$MISSING_PACKAGES"
507 507
508 508 printf "\ndo you want to install the missing packages right now? [y/n] "
509 509 read -r confirm
510 510 [ "$confirm" != "y" ] && exit 1
511 511
512 512 ## Make sure all missing required packages are installed
513 513 apt-get update && apt-get -qq -y install `echo "${MISSING_PACKAGES}" | sed "s/ //"`
514 514 fi
515 515
516 516 # Check if ./bootstrap.d directory exists
517 517 if [ ! -d "./bootstrap.d/" ] ; then
518 518 echo "error: './bootstrap.d' required directory not found!"
519 519 exit 1
520 520 fi
521 521
522 522 # Check if ./files directory exists
523 523 if [ ! -d "./files/" ] ; then
524 524 echo "error: './files' required directory not found!"
525 525 exit 1
526 526 fi
527 527
528 528 # Check if specified KERNELSRC_DIR directory exists
529 529 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
530 530 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
531 531 exit 1
532 532 fi
533 533
534 534 # Check if specified UBOOTSRC_DIR directory exists
535 535 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
536 536 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
537 537 exit 1
538 538 fi
539 539
540 540 # Check if specified VIDEOCORESRC_DIR directory exists
541 541 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
542 542 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
543 543 exit 1
544 544 fi
545 545
546 546 # Check if specified FBTURBOSRC_DIR directory exists
547 547 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
548 548 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
549 549 exit 1
550 550 fi
551 551
552 552 # Check if specified NEXMONSRC_DIR directory exists
553 553 if [ -n "$NEXMONSRC_DIR" ] && [ ! -d "$NEXMONSRC_DIR" ] ; then
554 554 echo "error: '${NEXMONSRC_DIR}' specified directory not found (NEXMONSRC_DIR)!"
555 555 exit 1
556 556 fi
557 557
558 558 # Check if specified CHROOT_SCRIPTS directory exists
559 559 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
560 560 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
561 561 exit 1
562 562 fi
563 563
564 564 # Check if specified device mapping already exists (will be used by cryptsetup)
565 565 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
566 566 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
567 567 exit 1
568 568 fi
569 569
570 570 # Don't clobber an old build
571 571 if [ -e "$BUILDDIR" ] ; then
572 572 echo "error: directory ${BUILDDIR} already exists, not proceeding"
573 573 exit 1
574 574 fi
575 575
576 576 # Setup chroot directory
577 577 mkdir -p "${R}"
578 578
579 579 # Check if build directory has enough of free disk space >512MB
580 580 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
581 581 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
582 582 exit 1
583 583 fi
584 584
585 585 set -x
586 586
587 587 # Call "cleanup" function on various signals and errors
588 588 trap cleanup 0 1 2 3 6
589 589
590 590 # Add required packages for the minbase installation
591 591 if [ "$ENABLE_MINBASE" = true ] ; then
592 592 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
593 593 fi
594 594
595 595 # Add parted package, required to get partprobe utility
596 596 if [ "$EXPANDROOT" = true ] ; then
597 597 APT_INCLUDES="${APT_INCLUDES},parted"
598 598 fi
599 599
600 600 # Add dphys-swapfile package, required to enable swap
601 601 if [ "$ENABLE_DPHYSSWAP" = true ] ; then
602 602 APT_INCLUDES="${APT_INCLUDES},dphys-swapfile"
603 603 fi
604 604
605 605 # Add dbus package, recommended if using systemd
606 606 if [ "$ENABLE_DBUS" = true ] ; then
607 607 APT_INCLUDES="${APT_INCLUDES},dbus"
608 608 fi
609 609
610 610 # Add iptables IPv4/IPv6 package
611 611 if [ "$ENABLE_IPTABLES" = true ] ; then
612 612 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
613 613 fi
614 614 # Add apparmor for KERNEL_SECURITY
615 615 if [ "$KERNEL_SECURITY" = true ] ; then
616 616 APT_INCLUDES="${APT_INCLUDES},apparmor,apparmor-utils,apparmor-profiles,apparmor-profiles-extra,libapparmor-perl"
617 617 fi
618 618
619 619 # Add openssh server package
620 620 if [ "$SSH_ENABLE" = true ] ; then
621 621 APT_INCLUDES="${APT_INCLUDES},openssh-server"
622 622 fi
623 623
624 624 # Add alsa-utils package
625 625 if [ "$ENABLE_SOUND" = true ] ; then
626 626 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
627 627 fi
628 628
629 629 # Add rng-tools package
630 630 if [ "$ENABLE_HWRANDOM" = true ] ; then
631 631 APT_INCLUDES="${APT_INCLUDES},rng-tools"
632 632 fi
633 633
634 634 # Add fbturbo video driver
635 635 if [ "$ENABLE_FBTURBO" = true ] ; then
636 636 # Enable xorg package dependencies
637 637 ENABLE_XORG=true
638 638 fi
639 639
640 640 # Add user defined window manager package
641 641 if [ -n "$ENABLE_WM" ] ; then
642 642 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
643 643
644 644 # Enable xorg package dependencies
645 645 ENABLE_XORG=true
646 646 fi
647 647
648 648 # Add xorg package
649 649 if [ "$ENABLE_XORG" = true ] ; then
650 650 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
651 651 fi
652 652
653 653 # Replace selected packages with smaller clones
654 654 if [ "$ENABLE_REDUCE" = true ] ; then
655 655 ## Add levee package instead of vim-tiny
656 656 if [ "$REDUCE_VIM" = true ] ; then
657 657 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
658 658 fi
659 659
660 660 ## Add dropbear package instead of openssh-server
661 661 if [ "$REDUCE_SSHD" = true ] ; then
662 662 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
663 663 fi
664 664 fi
665 665
666 666 # Configure systemd-sysv exclude to make halt/reboot/shutdown scripts available
667 667 if [ "$ENABLE_SYSVINIT" = false ] ; then
668 668 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
669 669 fi
670 670
671 671 # Configure kernel sources if no KERNELSRC_DIR
672 672 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
673 673 KERNELSRC_CONFIG=true
674 674 fi
675 675
676 676 # Configure reduced kernel
677 677 if [ "$KERNEL_REDUCE" = true ] ; then
678 678 KERNELSRC_CONFIG=false
679 679 fi
680 680
681 681 # Configure qemu compatible kernel
682 682 if [ "$ENABLE_QEMU" = true ] ; then
683 683 DTB_FILE=vexpress-v2p-ca15_a7.dtb
684 684 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
685 685 KERNEL_DEFCONFIG="vexpress_defconfig"
686 686 if [ "$KERNEL_MENUCONFIG" = false ] ; then
687 687 KERNEL_OLDDEFCONFIG=true
688 688 fi
689 689 fi
690 690
691 691 # Execute bootstrap scripts
692 692 for SCRIPT in bootstrap.d/*.sh; do
693 693 head -n 3 "$SCRIPT"
694 694 . "$SCRIPT"
695 695 done
696 696
697 697 ## Execute custom bootstrap scripts
698 698 if [ -d "custom.d" ] ; then
699 699 for SCRIPT in custom.d/*.sh; do
700 700 . "$SCRIPT"
701 701 done
702 702 fi
703 703
704 704 # Execute custom scripts inside the chroot
705 705 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
706 706 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
707 707 chroot_exec /bin/bash -x <<'EOF'
708 708 for SCRIPT in /chroot_scripts/* ; do
709 709 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
710 710 $SCRIPT
711 711 fi
712 712 done
713 713 EOF
714 714 rm -rf "${R}/chroot_scripts"
715 715 fi
716 716
717 717 # Remove c/c++ build environment from the chroot
718 718 chroot_remove_cc
719 719
720 720 # Generate required machine-id
721 721 MACHINE_ID=$(dbus-uuidgen)
722 722 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
723 723 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
724 724
725 725 # APT Cleanup
726 726 chroot_exec apt-get -y clean
727 727 chroot_exec apt-get -y autoclean
728 728 chroot_exec apt-get -y autoremove
729 729
730 730 # Unmount mounted filesystems
731 731 umount -l "${R}/proc"
732 732 umount -l "${R}/sys"
733 733
734 734 # Clean up directories
735 735 rm -rf "${R}/run/*"
736 736 rm -rf "${R}/tmp/*"
737 737
738 738 # Clean up APT proxy settings
739 739 if [ "$KEEP_APT_PROXY" = false ] ; then
740 740 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
741 741 fi
742 742
743 743 # Clean up files
744 744 rm -f "${ETC_DIR}/ssh/ssh_host_*"
745 745 rm -f "${ETC_DIR}/dropbear/dropbear_*"
746 746 rm -f "${ETC_DIR}/apt/sources.list.save"
747 747 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
748 748 rm -f "${ETC_DIR}/*-"
749 749 rm -f "${ETC_DIR}/resolv.conf"
750 750 rm -f "${R}/root/.bash_history"
751 751 rm -f "${R}/var/lib/urandom/random-seed"
752 752 rm -f "${R}/initrd.img"
753 753 rm -f "${R}/vmlinuz"
754 754 rm -f "${R}${QEMU_BINARY}"
755 755
756 756 if [ "$ENABLE_QEMU" = true ] ; then
757 757 # Setup QEMU directory
758 758 mkdir "${BASEDIR}/qemu"
759 759
760 760 # Copy kernel image to QEMU directory
761 761 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
762 762
763 763 # Copy kernel config to QEMU directory
764 764 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
765 765
766 766 # Copy kernel dtbs to QEMU directory
767 767 for dtb in "${BOOT_DIR}/"*.dtb ; do
768 768 if [ -f "${dtb}" ] ; then
769 769 install_readonly "${dtb}" "${BASEDIR}/qemu/"
770 770 fi
771 771 done
772 772
773 773 # Copy kernel overlays to QEMU directory
774 774 if [ -d "${BOOT_DIR}/overlays" ] ; then
775 775 # Setup overlays dtbs directory
776 776 mkdir "${BASEDIR}/qemu/overlays"
777 777
778 778 for dtb in "${BOOT_DIR}/overlays/"*.dtbo ; do
779 779 if [ -f "${dtb}" ] ; then
780 780 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
781 781 fi
782 782 done
783 783 fi
784 784
785 785 # Copy u-boot files to QEMU directory
786 786 if [ "$ENABLE_UBOOT" = true ] ; then
787 787 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
788 788 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
789 789 fi
790 790 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
791 791 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
792 792 fi
793 793 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
794 794 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
795 795 fi
796 796 fi
797 797
798 798 # Copy initramfs to QEMU directory
799 799 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
800 800 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
801 801 fi
802 802 fi
803 803
804 804 # Calculate size of the chroot directory in KB
805 805 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
806 806
807 807 # Calculate the amount of needed 512 Byte sectors
808 808 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
809 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
809 FRMW_SECTORS=$(expr 128 \* 1024 \* 1024 \/ 512)
810 810 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
811 811
812 812 # The root partition is EXT4
813 813 # This means more space than the actual used space of the chroot is used.
814 814 # As overhead for journaling and reserved blocks 35% are added.
815 815 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
816 816
817 817 # Calculate required image size in 512 Byte sectors
818 818 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
819 819
820 820 # Prepare image file
821 821 if [ "$ENABLE_SPLITFS" = true ] ; then
822 822 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
823 823 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
824 824 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
825 825 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
826 826
827 827 ## Write firmware/boot partition tables
828 828 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
829 829 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
830 830 EOM
831 831
832 832 ## Write root partition table
833 833 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
834 834 ${TABLE_SECTORS},${ROOT_SECTORS},83
835 835 EOM
836 836
837 ## Setup temporary loop devices
838 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
837 # Setup temporary loop devices
838 FRMW_LOOP="$(losetup -o 1M --sizelimit 128M -f --show "$IMAGE_NAME"-frmw.img)"
839 839 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
840 840 # ENABLE_SPLITFS=false
841 841 else
842 842 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
843 843 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
844 844
845 845 # Write partition table
846 846 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
847 847 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
848 848 ${ROOT_OFFSET},${ROOT_SECTORS},83
849 849 EOM
850 850
851 851 # Setup temporary loop devices
852 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
853 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
852 FRMW_LOOP="$(losetup -o 1M --sizelimit 128M -f --show "$IMAGE_NAME".img)"
853 ROOT_LOOP="$(losetup -o 129M -f --show "$IMAGE_NAME".img)"
854 854 fi
855 855
856 856 if [ "$ENABLE_CRYPTFS" = true ] ; then
857 857 # Create dummy ext4 fs
858 858 mkfs.ext4 "$ROOT_LOOP"
859 859
860 860 # Setup password keyfile
861 861 touch .password
862 862 chmod 600 .password
863 863 echo -n ${CRYPTFS_PASSWORD} > .password
864 864
865 865 # Initialize encrypted partition
866 866 cryptsetup --verbose --debug -q luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -h "${CRYPTFS_HASH}" -s "${CRYPTFS_XTSKEYSIZE}" .password
867 867
868 868 # Open encrypted partition and setup mapping
869 869 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
870 870
871 871 # Secure delete password keyfile
872 872 shred -zu .password
873 873
874 874 # Update temporary loop device
875 875 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
876 876
877 877 # Wipe encrypted partition (encryption cipher is used for randomness)
878 878 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
879 879 fi
880 880
881 881 # Build filesystems
882 882 mkfs.vfat "$FRMW_LOOP"
883 883 mkfs.ext4 "$ROOT_LOOP"
884 884
885 885 # Mount the temporary loop devices
886 886 mkdir -p "$BUILDDIR/mount"
887 887 mount "$ROOT_LOOP" "$BUILDDIR/mount"
888 888
889 889 mkdir -p "$BUILDDIR/mount/boot/firmware"
890 890 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
891 891
892 892 # Copy all files from the chroot to the loop device mount point directory
893 893 rsync -a "${R}/" "$BUILDDIR/mount/"
894 894
895 895 # Unmount all temporary loop devices and mount points
896 896 cleanup
897 897
898 898 # Create block map file(s) of image(s)
899 899 if [ "$ENABLE_SPLITFS" = true ] ; then
900 900 # Create block map files for "bmaptool"
901 901 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
902 902 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
903 903
904 904 # Image was successfully created
905 905 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
906 906 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
907 907 else
908 908 # Create block map file for "bmaptool"
909 909 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
910 910
911 911 # Image was successfully created
912 912 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
913 913
914 914 # Create qemu qcow2 image
915 915 if [ "$ENABLE_QEMU" = true ] ; then
916 916 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
917 917 QEMU_SIZE=16G
918 918
919 919 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
920 920 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
921 921
922 922 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
923 923 fi
924 924 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant